#ifndef __RAW_H__
#define __RAW_H__

#include "InputPlugin.h"

// derive a class from CInputPlugin
// this class will be used to get information on what files
// does it support, information about the files and 
// configuration etc.

class CRAWPlugin : public CInputPlugin
{
public:
    CRAWPlugin(HINSTANCE hDLLInstance,HWND hApolloWnd) : _hDLLInstance(hDLLInstance), _hApolloWnd(hApolloWnd) {}
    char *__cdecl GetDescription();

    CInputDecoder *__cdecl Open(char *filename,int audioDataOffset);
    BOOL __cdecl GetInfo(char *filename,int audioDataOffset,TrackInfo *trackInfo);
    void __cdecl AdditionalInfo(char *filename,int audioDataOffset);
    BOOL __cdecl IsSuitableFile(char *filename,int audioDataOffset);
    char *__cdecl GetExtensions();

    void __cdecl Config();
    void __cdecl About();

    void __cdecl Close() { delete this; }

private:
    HINSTANCE _hDLLInstance;
    HWND _hApolloWnd;
};

// derive a class from CInputDecoder
// this class will do the actual decoding

class CRAWDecoder : public CInputDecoder
{
public:
    CRAWDecoder(char *filename,int audioDataOffset);

    int __cdecl GetNextAudioChunk(void **buffer);
    int __cdecl SetPosition(int newPosition);
    
    void __cdecl SetEqualizer(BOOL equalize);
    void __cdecl AdjustEqualizer(int equalizerValues[16]);

    void __cdecl Close() { delete this; }

private:
    ~CRAWDecoder();

    HANDLE _hFile;
    void *_buffer;
    int _playingTime;
    int _beginOfRAWData;
};

#endif//__RAW_H__
